/* astal-notifd-0.1.vapi generated by valac 0.56.17, do not modify. */

/**
 * Get the singleton instance of [class@AstalNotifd.Notifd]
 */
[CCode (gir_namespace = "AstalNotifd", gir_version = "0.1")]
namespace AstalNotifd {
	/**
	 * The Notification daemon.
	 *
	 * This class queues up to become the next daemon, while acting as a proxy in the meantime.
	 */
	[CCode (cheader_filename = "astal-notifd.h")]
	public class Notifd : GLib.Object {
		public Notifd ();
		/**
		 * Get the singleton instance
		 */
		public static AstalNotifd.Notifd get_default ();
		/**
		 * Gets the [class@AstalNotifd.Notification] with id or null if there is no such Notification.
		 */
		public AstalNotifd.Notification get_notification (uint id);
		/**
		 * Indicate to frontends to not show popups to the user.
		 *
		 * This property does not have any effect on its own, its merely
		 * a value to use between the daemon process and proxies for frontends to use.
		 */
		public bool dont_disturb { get; set; }
		/**
		 * Ignore the timeout specified by incoming notifications.
		 *
		 * By default notifications can specify a timeout in milliseconds
		 * after which the daemon will resolve them even without user input.
		 */
		public bool ignore_timeout { get; set; }
		/**
		 * List of currently unresolved notifications.
		 */
		public GLib.List<weak AstalNotifd.Notification> notifications { owned get; }
		/**
		 * Emitted when the daemon receives a [class@AstalNotifd.Notification].
		 *
		 * @param id The ID of the Notification.
		 * @param replaced Indicates if an existing Notification was replaced.
		 */
		public signal void notified (uint id, bool replaced);
		/**
		 * Emitted when a [class@AstalNotifd.Notification] is resolved.
		 *
		 * @param id The ID of the Notification.
		 * @param reason The reason how the Notification was resolved.
		 */
		public signal void resolved (uint id, AstalNotifd.ClosedReason reason);
	}
	/**
	 * Class representing a notification.
	 */
	[CCode (cheader_filename = "astal-notifd.h")]
	public class Notification : GLib.Object {
		/**
		 * Resolve this notification with [enum@AstalNotifd.ClosedReason.DISMISSED_BY_USER].
		 */
		public void dismiss ();
		public bool get_bool_hint (string hint);
		public uint8 get_byte_hint (string hint);
		public GLib.Variant? get_hint (string hint);
		public int get_int_hint (string hint);
		public unowned string get_str_hint (string hint);
		/**
		 * Invoke an [struct@AstalNotifd.Action] of this notification.
		 *
		 * Note that this method just notifies the client that this action was invoked
		 * by the user. If for example this notification persists through the lifetime
		 * of the sending program this action will have no effect.
		 */
		public void invoke (string action_id);
		/**
		 * Indicates whether [struct@AstalNotifd.Action]
		 * identifier should be interpreted as a named icon.
		 */
		public bool action_icons { get; }
		/**
		 * List of [struct@AstalNotifd.Action] of the notification.
		 *
		 * Can be invoked by calling [method@AstalNotifd.Notification.invoke] with the action's id.
		 */
		public GLib.List<AstalNotifd.Action?> actions { get; }
		/** Icon name of the sending application. */
		public string app_icon { get; internal set; }
		/** Name of the sending application. */
		public string app_name { get; internal set; }
		/** Multi-line body of text, where each line is a paragraph. May contain markup. */
		public string body { get; internal set; }
		/**
		 * [[https://specifications.freedesktop.org/notification-spec/latest/categories.html]]
		 */
		public string category { get; }
		/** Specifies the name of the desktop filename representing the calling program. */
		public string desktop_entry { get; }
		/** Time in milliseconds after the notification expires. */
		public int expire_timeout { get; internal set; }
		/** Id of the notification. */
		public uint id { get; internal set; }
		/** Path of an image  */
		public string image { get; }
		/** Indicates whether notification is kept after action invocation.  */
		public bool resident { get; }
		/** The path to a sound file to play when the notification pops up.  */
		public string sound_file { get; }
		/** A themeable named sound from to play when the notification pops up */
		public string sound_name { get; }
		/** Single line overview of the notification. */
		public string summary { get; internal set; }
		/** Indicates to suppress playing any sounds. */
		public bool suppress_sound { get; }
		/** Unix time of when the notification was sent. */
		public int64 time { get; internal set; }
		/** Indicates that the notification should be excluded from persistency. */
		public bool transient { get; }
		/** [enum@AstalNotifd.Urgency] level of the notification. */
		public AstalNotifd.Urgency urgency { get; }
		/**
		 * Specifies the X location on the screen that the notification should point to.
		 * The "y" hint must also be specified.
		 */
		public int x { get; }
		/**
		 * Specifies the Y location on the screen that the notification should point to.
		 * The "x" hint must also be specified.
		 */
		public int y { get; }
		/**
		 * Emitted when an [struct@AstalNotifd.Action] of this notification is invoked.
		 *
		 * @param action_id id of the invoked action
		 */
		public signal void invoked (string action_id);
		/**
		 * Emitted when this this notification is resolved.
		 *
		 * @param reason The reason how the Notification was resolved.
		 */
		public signal void resolved (AstalNotifd.ClosedReason reason);
	}
	[CCode (cheader_filename = "astal-notifd.h")]
	public struct Action {
		public string id;
		public string label;
	}
	[CCode (cheader_filename = "astal-notifd.h")]
	public enum ClosedReason {
		EXPIRED,
		DISMISSED_BY_USER,
		CLOSED,
		UNDEFINED
	}
	[CCode (cheader_filename = "astal-notifd.h")]
	public enum Urgency {
		LOW,
		NORMAL,
		CRITICAL
	}
	[CCode (cheader_filename = "astal-notifd.h")]
	public const int MAJOR_VERSION;
	[CCode (cheader_filename = "astal-notifd.h")]
	public const int MICRO_VERSION;
	[CCode (cheader_filename = "astal-notifd.h")]
	public const int MINOR_VERSION;
	[CCode (cheader_filename = "astal-notifd.h")]
	public const string VERSION;
	[CCode (cheader_filename = "astal-notifd.h")]
	public static AstalNotifd.Notifd get_default ();
}
